#!/usr/bin/perl
# Zarafa Cluster-Backup thread spreader
# Zarafa, B.V.
# Usage: zarafa-cluster-multid.pl [-j N] [-l FLOAT] -- command [args...]
#   Ex.: echo -en "user1\nuser2\nuser3\nuser4" | zarafa-cluster-multid.pl -j4 /usr/bin/zarafa-backup -u
use Getopt::Long;
use File::Temp qw(tempfile);
use strict;
my @sysargs;
my($fh, $tempfile) = tempfile();
my %map;

&Getopt::Long::Configure(qw(bundling pass_through require_order));
&GetOptions(
	"j=i" => sub { push(@sysargs, "-j$_[1]"); },
	"l=s" => sub { push(@sysargs, "-l$_[1]"); },
);
while (defined(my $arg = <STDIN>)) {
	chomp($arg);
	my $key = $arg;
	$key =~ s{[^A-Za-z0-9]}{"_".unpack("H*", $&)}eg;
	$map{"t$key"} = $arg;
}
print $fh "all: ", join(" ", keys %map), "\n";
print $fh ".PHONY: all ", join(" ", keys %map), "\n";
foreach my $key (keys %map) {
	print $fh "$key: ; ", join(" ", @ARGV, $map{$key}), "\n";
}
system "make", @sysargs, "-s", "-f$tempfile";
unlink $tempfile;
